import { Lookup as LookupInterface, ServiceIdentifier } from '../interfaces/interfaces';
export declare class Lookup<T> implements LookupInterface<T> {
    private _map;
    constructor();
    getMap(): Map<ServiceIdentifier<unknown>, T[]>;
    add(serviceIdentifier: ServiceIdentifier, value: T): void;
    get(serviceIdentifier: ServiceIdentifier): T[];
    remove(serviceIdentifier: ServiceIdentifier): void;
    removeIntersection(lookup: LookupInterface<T>): void;
    removeByCondition(condition: (item: T) => boolean): T[];
    hasKey(serviceIdentifier: ServiceIdentifier): boolean;
    clone(): LookupInterface<T>;
    traverse(func: (key: ServiceIdentifier, value: T[]) => void): void;
    private _setValue;
}
