import { BindingInSyntax as IBindingInSyntax, BindingWhenSyntax as IBindingWhenSyntax, BindingOnSyntax as IBindingOnSyntax, BindingWhenOnSyntax, Binding, Request, Context } from '../interfaces/interfaces';
export declare class BindingInWhenOnSyntax<T> implements IBindingInSyntax<T>, IBindingWhenSyntax<T>, IBindingOnSyntax<T> {
    private _bindingInSyntax;
    private _bindingWhenSyntax;
    private _bindingOnSyntax;
    private _binding;
    constructor(binding: Binding<T>);
    inRequestScope(): BindingWhenOnSyntax<T>;
    inSingletonScope(): BindingWhenOnSyntax<T>;
    inTransientScope(): BindingWhenOnSyntax<T>;
    when(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    whenTargetNamed(name: string): IBindingOnSyntax<T>;
    whenTargetIsDefault(): IBindingOnSyntax<T>;
    whenTargetTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenInjectedInto(parent: Function | string): IBindingOnSyntax<T>;
    whenParentNamed(name: string): IBindingOnSyntax<T>;
    whenParentTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenAnyAncestorIs(ancestor: Function | string): IBindingOnSyntax<T>;
    whenNoAncestorIs(ancestor: Function | string): IBindingOnSyntax<T>;
    whenAnyAncestorNamed(name: string): IBindingOnSyntax<T>;
    whenAnyAncestorTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenNoAncestorNamed(name: string): IBindingOnSyntax<T>;
    whenNoAncestorTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenAnyAncestorMatches(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    whenNoAncestorMatches(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    onActivation(handler: (context: Context, injectable: T) => T): IBindingWhenSyntax<T>;
    onDeactivation(handler: (injectable: T) => void | Promise<void>): IBindingWhenSyntax<T>;
}
