import { Abstract, BindingToSyntax as IBindingToSyntax, BindingInWhenOnSyntax as IBindingInWhenOnSyntax, BindingWhenOnSyntax as IBindingWhenOnSyntax, Binding, Context, FactoryCreator, Newable, ProviderCreator, ServiceIdentifier } from '../interfaces/interfaces';
import { BindingInWhenOnSyntax } from './binding_in_when_on_syntax';
import { BindingWhenOnSyntax } from './binding_when_on_syntax';
export declare class BindingToSyntax<T> implements IBindingToSyntax<T> {
    private _binding;
    constructor(binding: Binding<T>);
    to(constructor: new (...args: never[]) => T): BindingInWhenOnSyntax<T>;
    toSelf(): IBindingInWhenOnSyntax<T>;
    toConstantValue(value: T): IBindingWhenOnSyntax<T>;
    toDynamicValue(func: (context: Context) => T): IBindingInWhenOnSyntax<T>;
    toConstructor<T2>(constructor: Newable<T2>): IBindingWhenOnSyntax<T>;
    toFactory<T2>(factory: FactoryCreator<T2>): IBindingWhenOnSyntax<T>;
    toFunction(func: T): IBindingWhenOnSyntax<T>;
    toAutoFactory<T2>(serviceIdentifier: ServiceIdentifier<T2>): IBindingWhenOnSyntax<T>;
    toAutoNamedFactory<T2>(serviceIdentifier: ServiceIdentifier<T2>): BindingWhenOnSyntax<T>;
    toProvider<T2>(provider: ProviderCreator<T2>): IBindingWhenOnSyntax<T>;
    toService(service: string | symbol | Newable<T> | Abstract<T>): void;
}
