import { BindingOnSyntax as IBindingOnSyntax, BindingWhenSyntax as IBindingWhenSyntax, Binding, Context, Request } from '../interfaces/interfaces';
export declare class BindingWhenOnSyntax<T> implements IBindingWhenSyntax<T>, IBindingOnSyntax<T> {
    private _bindingWhenSyntax;
    private _bindingOnSyntax;
    private _binding;
    constructor(binding: Binding<T>);
    when(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    whenTargetNamed(name: string): IBindingOnSyntax<T>;
    whenTargetIsDefault(): IBindingOnSyntax<T>;
    whenTargetTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenInjectedInto(parent: Function | string): IBindingOnSyntax<T>;
    whenParentNamed(name: string): IBindingOnSyntax<T>;
    whenParentTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenAnyAncestorIs(ancestor: Function | string): IBindingOnSyntax<T>;
    whenNoAncestorIs(ancestor: Function | string): IBindingOnSyntax<T>;
    whenAnyAncestorNamed(name: string): IBindingOnSyntax<T>;
    whenAnyAncestorTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenNoAncestorNamed(name: string): IBindingOnSyntax<T>;
    whenNoAncestorTagged(tag: string, value: any): IBindingOnSyntax<T>;
    whenAnyAncestorMatches(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    whenNoAncestorMatches(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    onActivation(handler: (context: Context, injectable: T) => T): IBindingWhenSyntax<T>;
    onDeactivation(handler: (injectable: T) => Promise<void> | void): IBindingWhenSyntax<T>;
}
