import { BindingOnSyntax as IBindingOnSyntax, BindingWhenSyntax as IBindingWhenSyntax, Binding, Request } from '../interfaces/interfaces';
export declare class BindingWhenSyntax<T> implements IBindingWhenSyntax<T> {
    private _binding;
    constructor(binding: Binding<T>);
    when(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    whenTargetNamed(name: string | number | symbol): IBindingOnSyntax<T>;
    whenTargetIsDefault(): IBindingOnSyntax<T>;
    whenTargetTagged(tag: string | number | symbol, value: any): IBindingOnSyntax<T>;
    whenInjectedInto(parent: NewableFunction | string): IBindingOnSyntax<T>;
    whenParentNamed(name: string | number | symbol): IBindingOnSyntax<T>;
    whenParentTagged(tag: string | number | symbol, value: any): IBindingOnSyntax<T>;
    whenAnyAncestorIs(ancestor: NewableFunction | string): IBindingOnSyntax<T>;
    whenNoAncestorIs(ancestor: NewableFunction | string): IBindingOnSyntax<T>;
    whenAnyAncestorNamed(name: string | number | symbol): IBindingOnSyntax<T>;
    whenNoAncestorNamed(name: string | number | symbol): IBindingOnSyntax<T>;
    whenAnyAncestorTagged(tag: string | number | symbol, value: unknown): IBindingOnSyntax<T>;
    whenNoAncestorTagged(tag: string | number | symbol, value: unknown): IBindingOnSyntax<T>;
    whenAnyAncestorMatches(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
    whenNoAncestorMatches(constraint: (request: Request) => boolean): IBindingOnSyntax<T>;
}
